/*
 * Length_Statistics.cpp
 *
 *  Created on: May 11, 2011
 *      Author: fritz
 */

#include "Length_Statistics.h"

void Length_Statistics::init() {
	this->size.resize((size_t) this->max_length, 0);
}

void Length_Statistics::add(char const * seq) {

	int i = 0;
	while (seq[i] != '\0') {
		i++;
	}
	//	cout<<i<<" "<<this->max_length<<endl;
	this->size[i]++;
	//	cout<<size[i]<<endl;
}

void Length_Statistics::print() {
	ofstream data;
	data.open(this->fileName.c_str(), std::ios::out);
	data.exceptions(ofstream::failbit | ofstream::badbit);
	data << "#ended reads at position\n";
	for (size_t i = 0; i < size.size(); i++) {
		data << size[i] << '\n';
	}

	size.clear();
	data.close();

	this->produce_plot();
}
void Length_Statistics::produce_plot() {
	ofstream script;

	script.open("script.R", std::ios::out);
	script << "source(\"/software/ngm/bin-linux/scripts/summaries.r\")\n";
	script << "png(\"";
	script << this->fileName;
	script << ".png\")\n";
	script << "length_plot(\"";
	script << this->fileName;
	script << "\")\n";
	script << "dev.off()\n";
	script.close();

	system("R CMD BATCH script.R ");

}
