#ifndef __ALIGNMENTDISPATCHER_H__
#define __ALIGNMENTDISPATCHER_H__

#include "IAlignment.h"

#include "NGMThreads.h"

class AlignmentDispatcher : public IAlignment
{
public:
	static AlignmentDispatcher * Instance();

	// Für den Dispatcher sind die Angaben nicht wirklich sinnvoll
	int GetScoreBatchSize() const;
	int GetAlignBatchSize() const;

	int BatchScore(
		int const mode,
		int const batchSize,
		char const * const * const refSeqList,
		char const * const * const qrySeqList,
		float * const results,
		void * extData);

	int BatchAlign(
		int const mode,
		int const batchSize,
		char const * const * const refSeqList,
		char const * const * const qrySeqList,
		Align * const results,
		void * extData);

	void Shutdown();
private:
	static void CreateInstance();

	AlignmentDispatcher();
	~AlignmentDispatcher();

	int InitAligners();

	static AlignmentDispatcher * sInstance;

	class Aligner;

	Aligner * PickFreeAligner();

	static const int cMaxAligner = 32;

	Aligner * m_Aligner[cMaxAligner];

	NGMMutex m_SelectionMutex;
	NGMThreadWait m_SelectionWait;

	int m_TotalAligner;
	int m_FreeAligner;
};

#endif
