#ifndef __REFENTRY_H__
#define __REFENTRY_H__

#include "SequenceLocation.h"
#include "Types.h"

struct RefEntry
{
	//static const int cIncrements[] = { 10, 20, 50, 100 };
	static int MaxRefsPerEntry;
	static int sICount;

	RefEntry(int locs = MaxRefsPerEntry)
	{
		ref = new SequenceLocation[locs];
		refCount = 0;
		refTotal = 0;
		nextEntry = 0;
		cached = false;
		++sICount;
	}
	~RefEntry()
	{
		if (nextEntry != 0)
			delete nextEntry;
		if (!cached)
			delete ref;
		--sICount;
	}
	int refCount;
	int refTotal;
	SequenceLocation * ref;
	RefEntry* nextEntry;
private:
	bool cached;
	RefEntry(void * pEntries, int count)
	{
		refCount = refTotal = count;
		cached = true;
		nextEntry = 0;
		ref = (SequenceLocation*)pEntries;
		++sICount;
	}

	friend class CSCache;
};

struct PrefixRefRelay
{
	static int sICount;
	ulong Prefix;
	RefEntry* Entry;
	PrefixRefRelay* Next;

	PrefixRefRelay() : Prefix(0), Entry(0), Next(0)
	{
		++sICount;
	}
	~PrefixRefRelay()
	{
		--sICount;
	}
};

#endif
